	--get the addon namespace
	local addon, ns = ...

	--object container
	local cfg = {}
	ns.cfg = cfg
	
	-----------------------------
	-- Death Knight extras
	-----------------------------
	
	cfg.deathknight = { -- Soul Reaper execute helper
		enable = true, 
		sound = false, -- set true if want sound to be played when in execute range
	}
	
	-----------------------------
	-- Paint
	-----------------------------
	
	cfg.paint = { -- Paints the frames of the UI. ( PlayerFrame, TargetFrame, FocusFrame, BossFrames, ArenaFrames etc... )
		enable = true, 
		classcolored = false, -- set true if want frames to be class colored
	}
	
	-----------------------------
	-- UnitFrames
	-----------------------------

	cfg.units = {
		player = {
			show = true,
			pos = { a1 = "CENTER", a2 = "CENTER", af = UIParent, x = -262, y = -190},
			scale = 1.15, -- 1.0 = 100%
			combat = {
				show = true,
				fadeIn = 1,
				fadeOut = 0.4,
			},
			castbar = { -- player castbar
				enable = true,
				pos = { a1 = "CENTER", a2 = "CENTER", af = UIParent, x = -1, y = -270 },
				scale = 1,
				onTop = {
					enable = false, -- ONLY enable if castbar is set underneath player frame
						pos = { a1 = "BOTTOM", a2 = "TOP", af = PlayerFrame, x = 15, y = 0 },
						scale = 1.5,
				},
			},
			expbar = { -- experience
				pos = { a1 = "BOTTOM", a2 = "BOTTOM", af = UIParent, x = 0, y = 0 },
				scale = 0.82,
				width = 410,
			},
			repbar = { -- reputation 
				pos = { a1 = "BOTTOM", a2 = "BOTTOM", af = UIParent, x = 0, y = -3 },
				scale = 0.82,
				width = 512, -- Less than 512 leaves textures behind
			},
		},
		target = {
			pos = { a1 = "CENTER", a2 = "CENTER", af = UIParent, x = 262, y = -190},
			scale = 1.15, -- 1.0 = 100% 
			combat = {
				show = false,
				fadeIn = 1,
				fadeOut = 0.2,
			},
			castbar = {
				enable = true,
				onTop = { -- Place castbar on top of TargetFrame
					enable = false, -- ONLY enable if detach is false
					pos = { a1 = "BOTTOM", a2 = "TOP", af = TargetFrame, x = -15, y = 0 },
					scale = 1.5,
				},
				detach = { -- Detach castbar from the TargetFrame
					enable = true,
					pos = { a1 = "CENTER", a2 = "CENTER", af = UIParent, x = -1, y = -150 },
					scale = 1.25,
				},
			},
			classcolored = {
				enable = true,
			},
		},
		focus = {
			pos = { a1 = "TOPRIGHT", a2 = "TOPRIGHT", af = TargetFrame, x = 275, y = -100},
			scale = 1.15, -- 1.0 = 100% 
			combat = {
				show = true,
				fadeIn = 1,
				fadeOut = 0.4,
			},
			castbar = {
				enable = true,
				onTop = { -- Place castbar on top of TargetFrame
					enable = false, -- ONLY enable if detach is false
					pos = { a1 = "BOTTOM", a2 = "TOP", af = FocusFrame, x = -15, y = 0 },
					scale = 1.25,
				},
				detach = { -- Detach castbar from the TargetFrame
					enable = true,
					pos = { a1 = "CENTER", a2 = "CENTER", af = UIParent, x = -1, y = -125 },
					scale = 1.15,
				},
			},
			classcolored = {
				enable = true,
			},
		},
		arena = {
			pos = { a1 = "CENTER", a2 = "CENTER", af = UIParent, x = 350, y = -100 }, -- Places ArenaEnemyFrame1 other 4 frames are above it / Also places the ArenaPrepFrames
			scale = 1.5,
			spacing = 15, -- how far apart each arena frame
		},
		boss = {
			pos = { a1 = "CENTER", a2 = "CENTER", af = UIParent, x = 550, y = -125 }, -- Places Boss1TargetFrame other 4 frames are above it
			scale = 1.25,
			spacing = -20, -- how far apart each boss frame
		},
		portraits ={
			classIcon = {
				enable = true,
				druidForms = true,
			},
		},
	}
	
	-----------------------------
	-- rActionBarStyler
	-----------------------------
	
	--use "/rabs" to see the command list
	cfg.bars = {
		--BAR 1
		bar1 = {
			enable          = true, --enable module
			uselayout2x6    = false,
			scale           = 0.92,
			padding         = 2, --frame padding
			buttons         = {
				size            = 26,
				margin          = 5,
			},
			pos             = { a1 = "BOTTOM", a2 = "BOTTOM", af = UIParent, x = -1, y = 222 },
			userplaced      = {
				enable          = true,
			},
			mouseover       = {
				enable          = true,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0.4},
			},
			combat          = { --fade the bar in/out in combat/out of combat
				enable          = true,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0.4},
			},
		},
		--OVERRIDE BAR (vehicle ui)
		overridebar = { --the new vehicle and override bar
			enable          = true, --enable module
			scale           = 0.82,
			padding         = 2, --frame padding
			buttons         = {
				size            = 57,
				margin          = 5,
			},
			pos             = { a1 = "BOTTOM", a2 = "BOTTOM", af = UIParent, x = -1, y = 222 },
			userplaced      = {
				enable          = true,
			},
			mouseover       = {
				enable          = false,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0.2},
			},
			combat          = { --fade the bar in/out in combat/out of combat
				enable          = false,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0.2},
			},
		},
		--BAR 2
		bar2 = {
			enable          = true, --enable module
			uselayout2x6    = false,
			scale           = 0.82,
			padding         = 2, --frame padding
			buttons         = {
				size            = 26,
				margin          = 5,
			},
			pos             = { a1 = "BOTTOM", a2 = "BOTTOM", af = UIParent, x = -1, y = 213 },
			userplaced      = {
				enable          = true,
			},
			mouseover       = {
				enable          = true,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0},
			},
			combat          = { --fade the bar in/out in combat/out of combat
				enable          = true,
				fadeIn          = {time = 0.4, alpha = 0.8},
				fadeOut         = {time = 0.3, alpha = 0},
			},
		},
		--BAR 3
		bar3 = {
			enable          = true, --enable module
			combineWithBar4AndBar5 = true, --by choosing true bar 3, 4 and 5 will react to the same hover effect, thus true/false at the same time, settings for bar4 and bar5 will be ignored
			vertical 		= true,
			scale           = 0.82,
			padding         = 2, --frame padding
			buttons         = {
				size            = 26,
				margin          = 5,
			},
			pos             = { a1 = "RIGHT", a2 = "RIGHT", af = UIParent, x = -0, y = 0 }, -- = { a1 = "BOTTOM", a2 = "BOTTOM", af = UIParent, x = -1, y = 213 }, -- places below mainactionbar
																							-- = { a1 = "RIGHT", a2 = "RIGHT", af = UIParent, x = -72, y = 0 }, -- places vertical left of bar 5 
			userplaced      = {
				enable          = true,
			},
			mouseover       = {
				enable          = true,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0},
			},
			combat          = { --fade the bar in/out in combat/out of combat
				enable          = false,
				fadeIn          = {time = 0.4, alpha = 0.4},
				fadeOut         = {time = 0.3, alpha = 0},
			},

		},
		--BAR 4
		bar4 = {
			enable          = true, --enable module
			combineBar4AndBar5  = true, --by choosing true both bar 4 and 5 will react to the same hover effect, thus true/false at the same time, settings for bar5 will be ignored
			scale           = 0.82,
			padding         = 10, --frame padding
			buttons         = {
				size            = 26,
				margin          = 5,
			},
			pos             = { a1 = "RIGHT", a2 = "RIGHT", af = UIParent, x = -0, y = 0 },
			userplaced      = {
				enable          = true,
			},
			mouseover       = {
				enable          = true,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0},
			},
			combat          = { --fade the bar in/out in combat/out of combat
				enable          = false,
				fadeIn          = {time = 0.4, alpha = 0.2},
				fadeOut         = {time = 0.3, alpha = 0},
			},
		},
		--BAR 5
		bar5 = {
			enable          = true, --enable module
			scale           = 0.82,
			padding         = 10, --frame padding
			buttons         = {
				size            = 26,
				margin          = 5,
			},
			pos             = { a1 = "RIGHT", a2 = "RIGHT", af = UIParent, x = -36, y = 0 },
			userplaced      = {
				enable          = true,
			},
			mouseover       = {
				enable          = true,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0.2},
			},
			combat          = { --fade the bar in/out in combat/out of combat
				enable          = false,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0.2},
			},
		},
		--PETBAR
		petbar = {
			enable          = true, --enable module
			show            = true, --true/false
			scale           = 0.82,
			padding         = 2, --frame padding
			buttons         = {
				size            = 26,
				margin          = 5,
			},
			pos             = { a1 = "BOTTOM", a2 = "BOTTOM", af = UIParent, x = -1, y = 284 },
			userplaced      = {
				enable          = true,
			},
			mouseover       = {
				enable          = true,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0.2},
			},
			combat          = { --fade the bar in/out in combat/out of combat
				enable          = true,
				fadeIn          = {time = 0.4, alpha = 0.8},
				fadeOut         = {time = 0.3, alpha = 0.2},
			},
		},
		--STANCE- + POSSESSBAR
		stancebar = {
			enable          = true, --enable module
			show            = true, --true/false
			scale           = 0.82,
			padding         = 2, --frame padding
			buttons         = {
				size            = 26,
				margin          = 5,
			},
			pos             = { a1 = "BOTTOM", a2 = "BOTTOM", af = UIParent, x = -1, y = 181 },
			userplaced      = {
				enable          = true,
			},
			mouseover       = {
				enable          = true,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0},
			},
			combat          = { --fade the bar in/out in combat/out of combat
				enable          = false,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0.2},
			},
		},
		--EXTRABAR
		extrabar = {
			enable          = true, --enable module
			scale           = 0.82,
			padding         = 10, --frame padding
			buttons         = {
				size            = 36,
				margin          = 5,
			},
			pos             = { a1 = "BOTTOM", a2 = "BOTTOM", af = UIParent, x = -220, y = 189 },
			userplaced      = {
				enable          = true,
			},
			mouseover       = {
				enable          = false,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0.2},
			},
		},
		--VEHICLE EXIT (no vehicleui)
		leave_vehicle = {
			enable          = true, --enable module
			scale           = 0.82,
			padding         = 10, --frame padding
			buttons         = {
				size            = 26,
				margin          = 5,
			},
			pos             = { a1 = "BOTTOM", a2 = "BOTTOM", af = UIParent, x = -3, y = 119 },
			userplaced      = {
				enable          = true,
			},
			mouseover       = {
				enable          = false,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0.2},
			},
		},
		--MICROMENU
		micromenu = {
			enable          = true, --enable module
			show            = true, --true/false
			scale           = 0.82,
			padding         = 10, --frame padding
			pos             = { a1 = "TOPLEFT", a2 = "TOPLEFT", af = UIParent, x = 31, y = 25 },
			userplaced      = {
				enable          = true,
			},
			mouseover       = {
				enable          = true,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0},
			},
		},
		--BAGS
		bags = {
			enable          = true, --enable module
			show            = true, --true/false
			scale           = 0.82,
			padding         = 15, --frame padding
			pos             = { a1 = "BOTTOMRIGHT", a2 = "BOTTOMRIGHT", af = UIParent, x = -0, y = 193 },
			userplaced      = {
				enable          = true,
			},
			mouseover       = {
				enable          = true,
				fadeIn          = {time = 0.4, alpha = 1},
				fadeOut         = {time = 0.3, alpha = 0},
			},
		},
	}
	
	-----------------------------
	-- rActionButtonStyler 
	-----------------------------

	cfg.textures = {
		normal            = "Interface\\AddOns\\SasUI\\media\\gloss",
		flash             = "Interface\\AddOns\\SasUI\\media\\flash",
		hover             = "Interface\\AddOns\\SasUI\\media\\hover",
		pushed            = "Interface\\AddOns\\SasUI\\media\\pushed",
		checked           = "Interface\\AddOns\\SasUI\\media\\checked",
		equipped          = "Interface\\AddOns\\SasUI\\media\\gloss_grey",
		buttonback        = "Interface\\AddOns\\SasUI\\media\\button_background",
		buttonbackflat    = "Interface\\AddOns\\SasUI\\media\\button_background_flat",
		outer_shadow      = "Interface\\AddOns\\SasUI\\media\\outer_shadow",
	}

	cfg.background = {
		showbg            = true,  --show an background image?
		showshadow        = true,   --show an outer shadow?
		useflatbackground = false,  --true uses plain flat color instead
		backgroundcolor   = { r = 0.2, g = 0.2, b = 0.2, a = 0.3},
		shadowcolor       = { r = 0, g = 0, b = 0, a = 0.9},
		classcolored      = false,
		inset             = 5,
	}

	cfg.color = {
		normal            = { r = 0.37, g = 0.3, b = 0.3, },
		equipped          = { r = 0.1, g = 0.5, b = 0.1, },
		classcolored      = false,
	}

	cfg.hotkeys = {
		show            = true,
		fontsize        = 12,
		pos1             = { a1 = "TOPRIGHT", x = 0, y = 0 },
		pos2             = { a1 = "TOPLEFT", x = 0, y = 0 }, --important! two points are needed to make the hotkeyname be inside of the button
	}

	cfg.macroname = {
		show            = true,
		fontsize        = 12,
		pos1             = { a1 = "BOTTOMLEFT", x = 0, y = 0 },
		pos2             = { a1 = "BOTTOMRIGHT", x = 0, y = 0 }, --important! two points are needed to make the macroname be inside of the button
	}

	cfg.itemcount = {
		show            = true,
		fontsize        = 12,
		pos1             = { a1 = "BOTTOMRIGHT", x = 0, y = 0 },
	}

	cfg.cooldown = {
		spacing         = 0,
	}

	cfg.font = STANDARD_TEXT_FONT
	
	-----------------------------
	-- rChat
	-----------------------------
	
	cfg.hideChatTabBackgrounds  = true
	cfg.selectedTabColor        = {1,0.75,0}
	cfg.selectedTabAlpha        = 1
	cfg.notSelectedTabColor     = {0.5,0.5,0.5}
	cfg.notSelectedTabAlpha     = 0.3
	
	-----------------------------
	-- rInfostrings
	-----------------------------
	
	cfg.frame = {
		scale           = 0.95,
		pos             = { a1 = "TOP", af = Minimap, a2 = "BOTTOM", x = 0, y = -15 },
		userplaced      = true, --want to place the bar somewhere else?
	}

	cfg.showXpRep     = false --show xp or reputation as string
	cfg.showMail      = false --show mail as text
	
	-----------------------------
	-- rMinimap
	-----------------------------
		
	cfg.mapcluster = {
		pos             = { a1 = "TOPRIGHT", af = UIParent, a2 = "TOPRIGHT", x = 0, y = 0 },
		userplaced      = true, --want to place the bar somewhere else?
		scale           = 0.82,
	}

	cfg.map = {
		pos             = { a1 = "TOP", x = 10, y = -20 }, --set the position of the minimap inside the minimap cluster
	}

	cfg.clock = { --the clock
		pos             = { a1 = "BOTTOM", af = Minimap, a2 = "BOTTOM", x = 0, y = 0 },
		font            = { size = 12, family = STANDARD_TEXT_FONT, outline = "THINOUTLINE", }
	}

	cfg.calendar = { --calendar button
		size            = 16,
		pos             = { a1 = "CENTER", af = Minimap, a2 = "CENTER", x = 52, y = 52 },
		font            = { size = 12, family = STANDARD_TEXT_FONT, outline = "THINOUTLINE", }
	}
	
	cfg.garrison = { --garrison button
		pos				= { a1 = "BOTTOMLEFT", af = Minimap, a2 = "TOPLEFT", x = -25, y = -65 },
		scale			= 0.65,
		--hide			= true,
	}

	cfg.mail = {
		size            = 16,
		pos             = { a1 = "CENTER", af = Minimap, a2 = "CENTER", x = 75, y = 0 },
	}

	cfg.tracking = {
		size            = 16,
		pos             = { a1 = "CENTER", af = Minimap, a2 = "CENTER", x = 68, y = 28 },
	}

	cfg.queue = { --queue button
		size            = 16,
		pos             = { a1 = "CENTER", af = Minimap, a2 = "CENTER", x = -52, y = -52 },
	}
	
	-----------------------------
	-- xCT
	-----------------------------
	
	ns.config={
	---------------------------------------------------------------------------------
	-- use ["option"] = true/false, to set options.
	-- options
		-- blizz damage options.
		["blizzheadnumbers"] = true,	-- use blizzard damage/healing output (above mob/player head)
		["damagestyle"] = true,		-- change default damage/healing font above mobs/player heads. you need to restart WoW to see changes! has no effect if blizzheadnumbers = false
		-- xCT outgoing damage/healing options
		["damage"] = true,		-- show outgoing damage in it's own frame
		["healing"] = true,		-- show outgoing healing in it's own frame
		["showhots"] = true,		-- show periodic healing effects in xCT healing frame.
		["damagecolor"] = true,		-- display damage numbers depending on school of magic, see http://www.wowwiki.com/API_COMBAT_LOG_EVENT
		["critprefix"] = "|cffFF0000*|r",	-- symbol that will be added before amount, if you deal critical strike/heal. leave "" for empty. default is red *
		["critpostfix"] = "|cffFF0000*|r",	-- postfix symbol, "" for empty.
		["icons"] = true,		-- show outgoing damage icons
		["iconsize"] = 22,		-- icon size of spells in outgoing damage frame, also has effect on dmg font size if it's set to "auto"
		["petdamage"] = true,		-- show your pet damage.
		["dotdamage"] = true,		-- show damage from your dots. someone asked an option to disable lol.
		["treshold"] = 1,		-- minimum damage to show in outgoing damage frame
		["healtreshold"] = 1,		-- minimum healing to show in incoming/outgoing healing messages.

		-- appearence
		["font"] = "Interface\\AddOns\\SasUI\\media\\fonts\\HOOGE.TTF",	-- "Fonts\\ARIALN.ttf" is default WoW font.
		["fontsize"] = 12,
		["fontstyle"] = "OUTLINE",	-- valid options are "OUTLINE", "MONOCHROME", "THICKOUTLINE", "OUTLINE,MONOCHROME", "THICKOUTLINE,MONOCHROME"
		["damagefont"] = "Interface\\AddOns\\SasUI\\media\\fonts\\HOOGE.TTF",	 -- "Fonts\\FRIZQT__.ttf" is default WoW damage font
		["damagefontsize"] = "auto",	-- size of xCT damage font. use "auto" to set it automatically depending on icon size, or use own value, 16 for example. if it's set to number value icons will change size.
		["timevisible"] = 3, 		-- time (seconds) a single message will be visible. 3 is a good value.
		["scrollable"] = false,		-- allows you to scroll frame lines with mousewheel.
		["maxlines"] = 64,		-- max lines to keep in scrollable mode. more lines=more memory. nom nom nom.

		-- justify messages in frames, valid values are "RIGHT" "LEFT" "CENTER"
		["justify_1"] = "LEFT",		-- incoming damage justify
		["justify_2"] = "RIGHT",	-- incoming healing justify
		["justify_3"] = "CENTER",	-- various messages justify (mana, rage, auras, etc)
		["justify_4"] = "RIGHT",	-- outgoing damage/healing justify

		-- class modules and goodies
		["stopvespam"] = false,		-- automaticly turns off healing spam for priests in shadowform. HIDE THOSE GREEN NUMBERS PLX!
		["dkrunes"] = true,		-- show deatchknight rune recharge
		["mergeaoespam"] = true,	-- merges multiple aoe spam into single message, can be useful for dots too.
		["mergeaoespamtime"] = 3,	-- time in seconds aoe spell will be merged into single message. minimum is 1.
		["killingblow"] = true,		-- tells you about your killingblows (works only with ["damage"] = true,)
		["dispel"] = true,		-- tells you about your dispels (works only with ["damage"] = true,)
		["interrupt"] = true,		-- tells you about your interrupts (works only with ["damage"] = true,)
	}
