--[[
	-----------------------------
	-- SetUp
	-----------------------------
	local D, C, L = unpack(select(2, ...))

	D.ChatSetup = function()
		FCF_ResetChatWindows()
		FCF_SetLocked(ChatFrame1, 1)
		FCF_DockFrame(ChatFrame2)
		FCF_SetLocked(ChatFrame2, 1)
		FCF_OpenNewWindow(GENERAL)
		FCF_SetLocked(ChatFrame3, 1)
		FCF_DockFrame(ChatFrame3)

		FCF_OpenNewWindow(LOOT)
		FCF_UnDockFrame(ChatFrame4)
		FCF_SetLocked(ChatFrame4, 1)
		ChatFrame4:Show()

		for i = 1, NUM_CHAT_WINDOWS do
			local frame = _G[format("ChatFrame%s", i)]
			local id = frame:GetID()
			FCF_SetChatWindowFontSize(nil, frame, 11)
			frame:Size(D.InfoLeftRightWidth + 1, 114)
			SetChatWindowSavedDimensions(id, D.Scale(D.InfoLeftRightWidth + 1), D.Scale(114))
			FCF_SavePositionAndDimensions(frame)
			if i == 1 then FCF_SetWindowName(frame, "G, S, P & W") end
			if i == 2 then FCF_SetWindowName(frame, "Log") end
			if i == 3 then FCF_SetWindowName(frame, "Whisper") end
			D.SetDefaultChatPosition(frame)
		end

		ChatFrame_RemoveAllMessageGroups(ChatFrame1)
		ChatFrame_RemoveChannel(ChatFrame1, TRADE)
		ChatFrame_RemoveChannel(ChatFrame1, GENERAL)
		ChatFrame_RemoveChannel(ChatFrame1, L["chat"]["defense"])
		ChatFrame_RemoveChannel(ChatFrame1, L["chat"]["recruitment"])
		ChatFrame_RemoveChannel(ChatFrame1, L["chat"]["lfg"])
		ChatFrame_AddMessageGroup(ChatFrame1, "SAY")
		ChatFrame_AddMessageGroup(ChatFrame1, "GUILD")
		ChatFrame_AddMessageGroup(ChatFrame1, "OFFICER")
		ChatFrame_AddMessageGroup(ChatFrame1, "GUILD_ACHIEVEMENT")
		ChatFrame_AddMessageGroup(ChatFrame1, "PARTY")
		ChatFrame_AddMessageGroup(ChatFrame1, "PARTY_LEADER")
		ChatFrame_AddMessageGroup(ChatFrame1, "INSTANCE_CHAT")
		ChatFrame_AddMessageGroup(ChatFrame1, "INSTANCE_CHAT_LEADER")
		ChatFrame_AddMessageGroup(ChatFrame1, "WHISPER")
		ChatFrame_AddMessageGroup(ChatFrame1, "BN_WHISPER")
		ChatFrame_AddMessageGroup(ChatFrame1, "BN_CONVERSATION")

		ChatFrame_RemoveAllMessageGroups(ChatFrame3)
		ChatFrame_AddMessageGroup(ChatFrame3, "WHISPER")
		ChatFrame_AddMessageGroup(ChatFrame3, "BN_WHISPER")
		ChatFrame_AddMessageGroup(ChatFrame3, "BN_CONVERSATION")

		ChatFrame_RemoveAllMessageGroups(ChatFrame4)
		ChatFrame_AddChannel(ChatFrame4, TRADE)
		ChatFrame_AddChannel(ChatFrame4, GENERAL)
		ChatFrame_AddChannel(ChatFrame4, L["chat"]["defense"])
		ChatFrame_AddChannel(ChatFrame4, L["chat"]["recruitment"])
		ChatFrame_AddChannel(ChatFrame4, L["chat"]["lfg"])
		ChatFrame_AddMessageGroup(ChatFrame4, "COMBAT_XP_GAIN")
		ChatFrame_AddMessageGroup(ChatFrame4, "COMBAT_HONOR_GAIN")
		ChatFrame_AddMessageGroup(ChatFrame4, "COMBAT_FACTION_CHANGE")
		ChatFrame_AddMessageGroup(ChatFrame4, "LOOT")
		ChatFrame_AddMessageGroup(ChatFrame4, "MONEY")
		ChatFrame_AddMessageGroup(ChatFrame4, "EMOTE")
		ChatFrame_AddMessageGroup(ChatFrame4, "YELL")
		ChatFrame_AddMessageGroup(ChatFrame4, "MONSTER_SAY")
		ChatFrame_AddMessageGroup(ChatFrame4, "MONSTER_EMOTE")
		ChatFrame_AddMessageGroup(ChatFrame4, "MONSTER_YELL")
		ChatFrame_AddMessageGroup(ChatFrame4, "MONSTER_WHISPER")
		ChatFrame_AddMessageGroup(ChatFrame4, "MONSTER_BOSS_EMOTE")
		ChatFrame_AddMessageGroup(ChatFrame4, "MONSTER_BOSS_WHISPER")
		ChatFrame_AddMessageGroup(ChatFrame4, "SYSTEM")
		ChatFrame_AddMessageGroup(ChatFrame4, "ERRORS")
		ChatFrame_AddMessageGroup(ChatFrame4, "IGNORED")
		ChatFrame_AddMessageGroup(ChatFrame4, "BG_HORDE")
		ChatFrame_AddMessageGroup(ChatFrame4, "BG_ALLIANCE")
		ChatFrame_AddMessageGroup(ChatFrame4, "BG_NEUTRAL")
		ChatFrame_AddMessageGroup(ChatFrame4, "AFK")
		ChatFrame_AddMessageGroup(ChatFrame4, "DND")
		ChatFrame_AddMessageGroup(ChatFrame4, "ACHIEVEMENT")
		ChatFrame_AddMessageGroup(ChatFrame4, "RAID")
		ChatFrame_AddMessageGroup(ChatFrame4, "RAID_LEADER")
		ChatFrame_AddMessageGroup(ChatFrame4, "RAID_WARNING")

		ToggleChatColorNamesByClassGroup(true, "SAY")
		ToggleChatColorNamesByClassGroup(true, "EMOTE")
		ToggleChatColorNamesByClassGroup(true, "YELL")
		ToggleChatColorNamesByClassGroup(true, "GUILD")
		ToggleChatColorNamesByClassGroup(true, "OFFICER")
		ToggleChatColorNamesByClassGroup(true, "GUILD_ACHIEVEMENT")
		ToggleChatColorNamesByClassGroup(true, "ACHIEVEMENT")
		ToggleChatColorNamesByClassGroup(true, "WHISPER")
		ToggleChatColorNamesByClassGroup(true, "PARTY")
		ToggleChatColorNamesByClassGroup(true, "PARTY_LEADER")
		ToggleChatColorNamesByClassGroup(true, "RAID")
		ToggleChatColorNamesByClassGroup(true, "RAID_LEADER")
		ToggleChatColorNamesByClassGroup(true, "RAID_WARNING")
		ToggleChatColorNamesByClassGroup(true, "BATTLEGROUND")
		ToggleChatColorNamesByClassGroup(true, "BATTLEGROUND_LEADER")
		ToggleChatColorNamesByClassGroup(true, "CHANNEL1")
		ToggleChatColorNamesByClassGroup(true, "CHANNEL2")
		ToggleChatColorNamesByClassGroup(true, "CHANNEL3")
		ToggleChatColorNamesByClassGroup(true, "CHANNEL4")
		ToggleChatColorNamesByClassGroup(true, "CHANNEL5")
		ToggleChatColorNamesByClassGroup(true, "INSTANCE_CHAT")
		ToggleChatColorNamesByClassGroup(true, "INSTANCE_CHAT_LEADER")
	end
--]]