		
	-----------------------------
	-- INIT
	-----------------------------

	--get the addon namespace
	local addon, ns = ...
	local gcfg = ns.cfg
	--get some values from the namespace
	local cfg = gcfg.units.focus
	
	local function Focus_Update()
		FocusFrame:ClearAllPoints()
		FocusFrame:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
		FocusFrame:SetScale(cfg.scale)
		if cfg.combat.show then
			FocusFrame:SetAlpha(cfg.combat.fadeOut)
		else
			FocusFrame:SetAlpha(1)
		end
	end
	local f = CreateFrame("Frame", nil, UIParent)
	f:RegisterEvent("PLAYER_REGEN_ENABLED")
	f:RegisterEvent("PLAYER_ENTERING_WORLD")
	f:SetScript("OnEvent", Focus_Update)
	
	if cfg.combat.show then
		local function FocusIn_Update()
			FocusFrame:SetAlpha(cfg.combat.fadeIn)
		end
		local f = CreateFrame("Frame", nil, UIParent)
		f:RegisterEvent("PLAYER_REGEN_DISABLED")
		f:SetScript("OnEvent", FocusIn_Update)	
	end
	
	-----------------------------
	-- ClassColored
	-----------------------------	
	if not cfg.classcolored.enable then return end
	local frame = CreateFrame("FRAME")
	frame:RegisterEvent("GROUP_ROSTER_UPDATE")
	frame:RegisterEvent("PLAYER_TARGET_CHANGED")
	frame:RegisterEvent("PLAYER_FOCUS_CHANGED")
	frame:RegisterEvent("UNIT_FACTION")

	local function eventHandler(self, event, ...)
		if UnitIsPlayer("focus") then
			c = RAID_CLASS_COLORS[select(2, UnitClass("focus"))]
			FocusFrameNameBackground:SetVertexColor(c.r, c.g, c.b)
		end
	end

	frame:SetScript("OnEvent", eventHandler)

	for _, BarTextures in pairs({TargetFrameNameBackground, FocusFrameNameBackground}) do
		BarTextures:SetTexture("Interface\\TargetingFrame\\UI-StatusBar")
	end
	
	-----------------------------
	-- CastBar
	-----------------------------
	local cfg = gcfg.units.focus.castbar
	if cfg.enable then
		local cfg = gcfg.units.focus.castbar.onTop
		if cfg.enable then
			FocusFrameSpellBar:ClearAllPoints()
			FocusFrameSpellBar:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
			FocusFrameSpellBar.SetPoint = function() end
			FocusFrameSpellBar:SetScale(cfg.scale)
		end
		
		local cfg = gcfg.units.focus.castbar.detach
		if cfg.enable then
			FocusFrameSpellBar:ClearAllPoints()
			FocusFrameSpellBar:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
			FocusFrameSpellBar.SetPoint = function() end
			FocusFrameSpellBar:SetScale(cfg.scale)
		end
	else
		FocusFrameSpellBar:UnregisterAllEvents()
	end