	
	-----------------------------
	-- INIT
	-----------------------------

	--get the addon namespace
	local addon, ns = ...
	local gcfg = ns.cfg
	--get some values from the namespace
	local cfg = gcfg.units.player
	
	local function Player_Update()
		PlayerFrame:ClearAllPoints()
		PlayerFrame:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
		PlayerFrame:SetScale(cfg.scale)
		if cfg.combat.show then
			PlayerFrame:SetAlpha(cfg.combat.fadeOut)
		else
			PlayerFrame:SetAlpha(1)
		end
		PlayerFrame:SetUserPlaced(true) -- Entering Vehicle no longer moves the frame 
	end
	local f = CreateFrame("Frame", nil, UIParent)
	f:RegisterEvent("PLAYER_REGEN_ENABLED")
	f:RegisterEvent("PLAYER_ENTERING_WORLD")
	f:SetScript("OnEvent", Player_Update)
	
	if cfg.combat.show then
		local function PlayerIn_Update()
			PlayerFrame:SetAlpha(cfg.combat.fadeIn)
		end
		local f = CreateFrame("Frame", nil, UIParent)
		f:RegisterEvent("PLAYER_REGEN_DISABLED")
		f:SetScript("OnEvent", PlayerIn_Update)	
	end
	
	-----------------------------
	-- ExpBar
	-----------------------------
	
	--create the frame to hold the buttons
	local frame = CreateFrame("Frame", "ExpBar", UIParent)
	local cfg = gcfg.units.player.expbar
	frame:SetSize(512,36)
	frame:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
	frame:SetScale(cfg.scale)

	--move the buttons into position and reparent them
	MainMenuExpBar:SetParent(frame)
	MainMenuExpBar:EnableMouse(true)
	MainMenuExpBar:ClearAllPoints()
	MainMenuExpBar:SetPoint("CENTER")
	MainMenuExpBar.ignoreFramePositionManager = true
	
	-----------------------------
	-- RepBar
	-----------------------------

	hooksecurefunc("ReputationWatchBar_Update",function()
		local cfg = gcfg.units.player.repbar
		ReputationWatchBar:SetParent(UIParent)
		ReputationWatchBar:EnableMouse(true)
		ReputationWatchBar:ClearAllPoints()
		ReputationWatchBar:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
		ReputationWatchBar:SetScale(cfg.scale)
		ReputationWatchBar.ignoreFramePositionManager = true
	end)
--[[
	-- test how many times the RepBar is called and changed in a /reload
	hooksecurefunc(ReputationWatchBar,"SetPoint",function(self,anchorPoint,relativeTo,relativePoint,x,y)
		print("ReputationWatchBar:SetPoint(",anchorPoint,relativeTo:GetName(),relativePoint,x,y,")")
	end)
--]]

	-----------------------------
	-- CastBar
	-----------------------------
	
	CastingBarFrame.timer = CastingBarFrame:CreateFontString(nil);
	CastingBarFrame.timer:SetFont(STANDARD_TEXT_FONT,12,"OUTLINE");
	CastingBarFrame.timer:SetPoint("BOTTOM", CastingBarFrame, "TOP", 0, 0);
	CastingBarFrame.update = .1;

	hooksecurefunc("CastingBarFrame_OnUpdate", function(self, elapsed)
		if not self.timer then return end
		if self.update and self.update < elapsed then
			if self.casting then
				self.timer:SetText(format("%2.1f/%1.1f", max(self.maxValue - self.value, 0), self.maxValue))
			elseif self.channeling then
				self.timer:SetText(format("%.1f", max(self.value, 0)))
			else
				self.timer:SetText("")
			end
			self.update = .1
		else
			self.update = self.update - elapsed
		end
	end)
	
	--create the frame to hold the buttons
	local frame = CreateFrame("Frame", "CastBar", UIParent, "SecureHandlerStateTemplate")
	local cfg = gcfg.units.player.castbar
	if cfg.enable then
		frame:SetSize(36,36)
		frame:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
		frame:SetScale(cfg.scale)

		--move the buttons into position and reparent them
		CastingBarFrame:SetParent(frame)
		CastingBarFrame:EnableMouse(false)
		CastingBarFrame:ClearAllPoints()
		CastingBarFrame:SetPoint("CENTER")
		CastingBarFrame.ignoreFramePositionManager = true

		local cfg = gcfg.units.player.castbar.onTop
		if not cfg.enable then return end
		hooksecurefunc("PlayerFrame_AdjustAttachments", function()
		  if (PLAYER_FRAME_CASTBARS_SHOWN) then
			CastingBarFrame:ClearAllPoints()
			CastingBarFrame:SetPoint(cfg.pos.a1, cfg.pos.af, cfg.pos.a2, cfg.pos.x, cfg.pos.y)
			CastingBarFrame:SetScale(cfg.scale)
		  end
		end)
	else
		CastingBarFrame:UnregisterAllEvents()
	end
	
